
!BindingsDescriptor methodsFor: 'comparing' stamp: 'topa 2/9/2010 09:58'!
= aBindingsDescriptor
	"Bindings Descriptors are identical iff they have the same inner values"

	^ self == aBindingsDescriptor
		ifTrue: [true]
		ifFalse:[
			(self origin     = aBindingsDescriptor origin) and: [
			(self localKeyPath = aBindingsDescriptor localKeyPath) and: [
			(self target    = aBindingsDescriptor target) and: [
			(self keyPath  = aBindingsDescriptor keyPath)]]]]
			! !

!BindingsDescriptor methodsFor: 'accessing' stamp: 'topa 2/9/2010 09:58'!
bindingType

	^ bindingType! !

!BindingsDescriptor methodsFor: 'accessing' stamp: 'topa 2/9/2010 09:58'!
bindingType: type

	bindingType := type.! !

!ChangeDescriptorMessage methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:25'!
changedValue

	^ changedValue! !

!ChangeDescriptorMessage methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:25'!
changedValue: value

	changedValue := value.! !

!ChangeDescriptorMessage methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:25'!
keyPathOfChange

	^ keyPathOfChange! !

!ChangeDescriptorMessage methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:25'!
keyPathOfChange: keyPath

	keyPathOfChange := keyPath.! !

!ChangeDescriptorMessage methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:25'!
lastSender

	^ lastSender! !

!ChangeDescriptorMessage methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:25'!
lastSender: sender

	lastSender := sender.! !

!ChangeDescriptorMessage methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:25'!
operation

	^ operation! !

!ChangeDescriptorMessage methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:25'!
operation: anOperation

	operation := anOperation.! !

!AccessDescriptorMessage methodsFor: 'accessing' stamp: 'topa 2/9/2010 09:55'!
accessedKeyPath

	^ accessedKeyPath! !

!AccessDescriptorMessage methodsFor: 'accessing' stamp: 'topa 2/9/2010 09:55'!
accessedKeyPath: keyPath

	accessedKeyPath := keyPath.! !

!AccessDescriptorMessage methodsFor: 'accessing' stamp: 'topa 2/9/2010 09:55'!
accessedValue

	^ accessedValue! !

!AccessDescriptorMessage methodsFor: 'accessing' stamp: 'topa 2/9/2010 09:55'!
accessedValue: aValue

	accessedValue := aValue.! !

!AccessDescriptorMessage methodsFor: 'accessing' stamp: 'topa 2/9/2010 09:55'!
lastSender

	^ lastSender! !

!AccessDescriptorMessage methodsFor: 'accessing' stamp: 'topa 2/9/2010 09:55'!
lastSender: sender

	lastSender := sender.! !

!ManagedCollection methodsFor: 'private' stamp: 'topa 2/9/2010 10:26'!
actualCollection

	^ actualCollection! !

!ManagedCollection methodsFor: 'private' stamp: 'topa 2/9/2010 10:26'!
actualCollection: aCollection

	actualCollection :=  aCollection.! !

!ManagedCollection methodsFor: 'changing' stamp: 'topa 2/9/2010 10:35'!
add: anObject
	"notifies bindees that anyone has changed collection
	and forwards message to inner collection"

	| ret changedescriptor |
	
	changedescriptor := ChangeDescriptorMessage new
			operation: #add;
			keyPathOfChange: #();
			lastSender: self;
			changedValue: anObject.

	self bindings triggerEvent: #aboutToChange with: changedescriptor.
	ret := self actualCollection add: anObject.
	self bindings triggerEvent: #hasChanged with: changedescriptor.
	^ ret! !

!ManagedCollection methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:36'!
arrangedObjects
	"the arrangedobjects somebody can bind to (mapped to the actual collection)"

	<bindableAsCollection>
	self bindings triggerEvent: #accessed with: (self -> #arrangedObjects).
	^ self actualCollection! !

!ManagedCollection methodsFor: 'changing' stamp: 'topa 2/9/2010 10:32'!
at: aKey put: anObject
	"notifies bindees that anyone has changed collection
	and forwards message to inner collection"

	self flag: #NeedsReview.
	^ (self actualCollection respondsTo: #at:put:)
		ifTrue: [ | ret |
			self bindings triggerEvent: #aboutToChange with: anObject.
			"unregister old object, if present"
			ret := self actualCollection at: aKey put: anObject.
			"register new object"
			self bindings triggerEvent: #hasChanged with: anObject.
			ret]
		ifFalse: [self actualCollection at: aKey put: anObject]
! !

!ManagedCollection methodsFor: 'changing' stamp: 'topa 2/9/2010 10:32'!
do: aBlock
	"notifies bindees that anyone has accessed collection
	and forwards message to inner collection"

	self flag: #NeedsReview.
	self bindings triggerEvent: #accessed with: (self -> #arrangedObjects).
	^ self actualCollection do: aBlock.
! !

!ManagedCollection methodsFor: 'error handling' stamp: 'topa 2/9/2010 10:36'!
doesNotUnderstand: aMessage
	"forwards the not understood message to the inner collection.
	in the case that something is changed, this method calls an event hasChanged:"

	self flag: #NeedsReview.
	(self class knownMutators includes: aMessage selector)
		ifTrue: [
			| result |	
			self bindings triggerEvent: #aboutToChange with: (self actualCollection "????" -> aMessage selector).
			result := self actualCollection perform: aMessage selector withArguments: aMessage arguments.
			self bindings triggerEvent: #hasChanged with: (self actualCollection "????" -> aMessage selector).
			^ result	].
	^ self actualCollection perform: aMessage selector withArguments: aMessage arguments ! !

!ManagedCollection methodsFor: 'changing' stamp: 'topa 2/9/2010 10:35'!
remove: anObject ifAbsent: aBlock
	"notifies bindees that anyone has changed collection
	and forwards message to inner collection"

	| ret changedescriptor |
	
	changedescriptor := ChangeDescriptorMessage new
			operation: #remove;
			keyPathOfChange: #();
			lastSender: self;
			changedValue: anObject.
	
	self bindings triggerEvent: #aboutToChange with: changedescriptor.
	ret := self actualCollection remove: anObject ifAbsent: aBlock.
	self bindings triggerEvent: #hasChanged with: changedescriptor.
	^ ret! !

!BindingsManager methodsFor: 'reacting' stamp: 'topa 2/9/2010 09:58'!
aboutToChange: aBindingAssoc
	"aboutToChange: is just an option to react
	if s.b. wants to change, a.t.m. nobody reacts"! !

!BindingsManager methodsFor: 'reacting' stamp: 'topa 2/9/2010 09:58'!
accessed: anAccessDescriptorMessage
	"accessed is just an option to react, if somebody
	has accessed a variable and a.t.m. is not implemented"! !

!BindingsManager methodsFor: 'termination' stamp: 'topa 2/9/2010 09:57'!
alreadyContainsKey: localKeyPath
	" ^ <Boolean> "

	^ (self observedBindings 
		at: localKeyPath 
		ifAbsent: [OrderedCollection new])
			isEmpty not! !

!BindingsManager methodsFor: 'accessing' stamp: 'topa 2/9/2010 09:59'!
bindingDescriptorForChangeDescriptor: aChangeDescriptor
	"For a BindingsAssociation that arrives from the other side,
	the corresponding (already set up) BindingsDescriptor is returned"

	|  target keyPath |
	target := aChangeDescriptor lastSender.
	keyPath := aChangeDescriptor keyPathOfChange.

	^ self allObservedBindings 
		detect: [:bd| 
			(bd target = target) and: [
			(bd keyPath = keyPath) and: [
			bd origin = self target]]]
		ifNone: [nil]! !

!BindingsManager methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:00'!
bindingDescriptorsForInnerChangeDescriptor: aChangeDescriptor
	"For a BindingsAssociation that arrives from the other side,
	the corresponding (already set up) BindingsDescriptor is returned"
	
	|  target keyPath foundDescriptors |
	target := aChangeDescriptor lastSender.
	keyPath := aChangeDescriptor keyPathOfChange.
	foundDescriptors := OrderedCollection new.

	self allInnerBindings 
		do: [:bd| 
			((bd target = target) and: [
			(bd keyPath = keyPath) and: [
			bd origin = self target]])
				ifTrue: [	foundDescriptors add: bd]].
	^foundDescriptors.! !

!BindingsManager methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:02'!
hasChanged: aChangeDescriptorMessage
	"if a value has changed on the other side, then this method
	is called with a ChangeDescriptor Message
	The BindingsDescriptor is searched and the Morph setter called."

	| descriptor innerDescriptors |
	descriptor := self bindingDescriptorForChangeDescriptor: aChangeDescriptorMessage.
	innerDescriptors := self bindingDescriptorsForInnerChangeDescriptor: aChangeDescriptorMessage.

	"is incoming message from other side?"
	descriptor ifNotNil: [self otherSideHasChanged: descriptor].
		
	"If incoming message from inner bindings, then:
	Send ChangeDescriptorMessage to next receiver"
	innerDescriptors do: [:bindingDescriptor |
		"Change ChangeDescriptorMessage's lastSender and keypath"
		aChangeDescriptorMessage 
			lastSender: self target;
			keyPathOfChange: bindingDescriptor localKeyPath.
		self triggerEvent: #hasChanged with: aChangeDescriptorMessage].! !

!BindingsManager methodsFor: 'initialize-release' stamp: 'topa 2/9/2010 10:11'!
initialize

	self 
		observedBindings: Dictionary new;
		innerBindings: Dictionary new.! !

!BindingsManager methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:03'!
innerBindings

	^ innerBindings! !

!BindingsManager methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:03'!
innerBindings: aDict

	innerBindings := aDict.! !

!BindingsManager methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:03'!
innerKey: aKey
	"Fetches one observed binding"

	^ self innerBindings at: aKey ifAbsentPut: [Set new]! !

!BindingsManager methodsFor: 'establishing' stamp: 'topa 2/9/2010 10:11'!
installEventHandlers: aBindingsDescriptor
	"makes the BindingsManager on the other side react
	on events with accessed:/aboutToChange:/hasChanged:"

	#( accessed aboutToChange hasChanged ) do: [:eventSymbol |
		aBindingsDescriptor target bindings 
			when: eventSymbol
			send: eventSymbol asMutator
			to: aBindingsDescriptor origin bindings].! !

!BindingsManager methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:04'!
observedBindings

	^ observedBindings! !

!BindingsManager methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:04'!
observedBindings: aCollection

	observedBindings := aCollection.! !

!BindingsManager methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:04'!
observedKey: aKey
	"Fetches a set of observed bindings for that key"

	^ self observedBindings at: aKey ifAbsentPut: [Set new]! !

!BindingsManager methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:10'!
otherSideHasChanged: descriptor
	"if a value has changed on the other side, then this method
	is called with the Descriptor."

	(descriptor bindingType == #collection) ifTrue: [
		| ownvalues othervalues |
		"fetch values from the other side"
		othervalues := descriptor target getValuesFromKeypath: descriptor keyPath.
		"get the collection from this side"
		ownvalues := self target getCollectionsFromKeypath: descriptor localKeyPath.
		
		self flag: #todo. 
			"look if the target collection has any set up innerbinding.
			then it must have string values."		
			"else it must have complex objects as values."

		"remove all values, iterate over collection and add values"
		ownvalues do: [:collection |
			collection removeAll.
			othervalues do: [ :value | collection add: value]]].
				
	(descriptor bindingType == #value) ifTrue: [
		| ownmessageName ownvalues othermessageName othervalues |
		"fetch the last symbol"
		ownmessageName := descriptor localKeyPath last asMutator.
		"get the parent value object with the remaining symbols"
		ownvalues := descriptor origin getValuesFromKeypath: descriptor localKeyPath allButLast.
		"get the other side's message name"
		othermessageName := descriptor keyPath last.
		"get the other side's value object with the other side's descriptor"
		othervalues := descriptor target getValuesFromKeypath: descriptor keyPath allButLast.
		"set the first found value with first value from the other side"
		ownvalues first perform: ownmessageName with: (othervalues first perform: othermessageName)].! !

!BindingsManager methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:12'!
propertyName

	^ propertyName! !

!BindingsManager methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:12'!
propertyName: name

	propertyName := propertyName.! !

!BindingsManager methodsFor: 'establishing' stamp: 'topa 2/9/2010 10:18'!
recordBinding: aBindingsDescriptor
	
	(self observedKey: aBindingsDescriptor localKeyPath) 
		add: aBindingsDescriptor.! !

!BindingsManager methodsFor: 'establishing' stamp: 'topa 2/9/2010 10:18'!
recordInnerBinding: aBindingsDescriptor

	(self innerKey: aBindingsDescriptor localKeyPath) 
		add: aBindingsDescriptor.! !

!BindingsManager methodsFor: 'establishing' stamp: 'topa 2/9/2010 10:18'!
recordObservedBinding: aBindingsDescriptor

	(self observedKey: aBindingsDescriptor localKeyPath) 
		add: aBindingsDescriptor.! !

!BindingsManager methodsFor: 'establishing' stamp: 'topa 2/9/2010 10:19'!
startObservingKey: localKeyPath as: type notifying: aMorph with: aKeyPath
	"builds a Bindings Descriptor for new Binding, adds it and installs it"

	| descriptor |
	descriptor := (BindingsDescriptor as: type origin: (self target) localKeyPath: localKeyPath target: aMorph keyPath: aKeyPath).
	self
		recordObservedBinding: descriptor;
		installEventHandlers: descriptor.
! !

!BindingsManager methodsFor: 'termination' stamp: 'topa 2/9/2010 10:22'!
stopObservingKey: localKeyPath regarding: aMorph with: aKeyPath

	| foundDescriptors wantedDescriptor |
	
	wantedDescriptor := (BindingsDescriptor origin: (self target) localKeyPath: localKeyPath target: aMorph keyPath: aKeyPath).
	foundDescriptors := self observedBindings at: localKeyPath ifAbsent: [OrderedCollection new].
	
	foundDescriptors do: [:foundDescriptor |
		((foundDescriptor target = wantedDescriptor target) and:
			[foundDescriptor keyPath = wantedDescriptor keyPath])
			ifTrue: [
				self 
					forgetBinding: foundDescriptor;
					removeEventHandlers: foundDescriptor]].! !

!BindingsManager methodsFor: 'accessing' stamp: 'topa 2/9/2010 10:22'!
target: aMorph

	target := aMorph.! !

!BindingsManager methodsFor: 'establishing' stamp: 'topa 2/9/2010 10:23'!
watchInnerKey: localKeyPath as: type notifying: aMorph with: aKeyPath
	"builds a Bindings Descriptor for new Binding, adds it and installs it"

	| descriptor |
	descriptor := (BindingsDescriptor as: type origin: (self target) localKeyPath: localKeyPath target: aMorph keyPath: aKeyPath).
	self
		recordInnerBinding: descriptor;
		installEventHandlers: descriptor.
! !

!Object methodsFor: '*bindings-support' stamp: 'topa 2/9/2010 10:54'!
instVarNamedOrNil: name

	^ self instVarNamed: name ifAbsent: [^ nil]! !

!SelectableListMorph methodsFor: 'selection' stamp: 'topa 2/9/2010 10:48'!
selectionIndex: index
	"Called from outside to request setting a new selection."

	<bindable>
	| row selectionDesc selectionIndexDesc |
	"bindings stub"
	(self listMorph selectedRow = index) ifTrue: [^self].
	selectionDesc := ChangeDescriptorMessage new
		operation: #selection; keyPathOfChange: #(); lastSender: self; changedValue: index.
	selectionIndexDesc := ChangeDescriptorMessage new
		operation: #selectionIndex; keyPathOfChange: #(); lastSender: self; changedValue: index.
	self bindings triggerEvent: #aboutToChange with: selectionDesc.
	self bindings triggerEvent: #aboutToChange with: selectionIndexDesc.

	"Called internally to select the index-th item."
	self unhighlightSelection.
	row := index ifNil: [ 0 ].
	row := row min: self getListSize.  "make sure we don't select past the end"
	self listMorph selectedRow: row.
	self highlightSelection.
	self scrollSelectionIntoView.
	
	self bindings triggerEvent: #hasChanged with: selectionIndexDesc.
	self bindings triggerEvent: #hasChanged with: selectionDesc.
! !
