
!BindingsDescriptor methodsFor: 'comparing' stamp: 'AK 1/31/2010 15:11'!
= aBindingsDescriptor
"Bindings Descriptors are identical iff they have the same inner values"

	^ self == aBindingsDescriptor
		ifTrue: [true]
		ifFalse:[
			(self origin     = aBindingsDescriptor origin) and: [
			(self localKeyPath = aBindingsDescriptor localKeyPath) and: [
			(self target    = aBindingsDescriptor target) and: [
			(self keyPath  = aBindingsDescriptor keyPath)]]]]
			! !

!BindingsDescriptor methodsFor: 'accessing' stamp: 'AK 2/5/2010 23:18'!
bindingType
	^bindingType! !

!BindingsDescriptor methodsFor: 'accessing' stamp: 'AK 2/5/2010 23:18'!
bindingType: type
	bindingType := type.! !

!ChangeDescriptorMessage methodsFor: 'accessing' stamp: 'AK 2/6/2010 14:44'!
changedValue
	^changedValue! !

!ChangeDescriptorMessage methodsFor: 'accessing' stamp: 'AK 2/6/2010 14:45'!
changedValue: value
	changedValue := value! !

!ChangeDescriptorMessage methodsFor: 'accessing' stamp: 'AK 2/6/2010 14:45'!
keyPathOfChange
	^keyPathOfChange! !

!ChangeDescriptorMessage methodsFor: 'accessing' stamp: 'AK 2/6/2010 14:45'!
keyPathOfChange: keyPath
	keyPathOfChange := keyPath! !

!ChangeDescriptorMessage methodsFor: 'accessing' stamp: 'AK 2/6/2010 14:45'!
lastSender
	^lastSender! !

!ChangeDescriptorMessage methodsFor: 'accessing' stamp: 'AK 2/6/2010 14:45'!
lastSender: sender
	lastSender := sender! !

!ChangeDescriptorMessage methodsFor: 'accessing' stamp: 'AK 2/6/2010 14:47'!
operation
	^operation! !

!ChangeDescriptorMessage methodsFor: 'accessing' stamp: 'AK 2/6/2010 14:47'!
operation: anOperation
	operation := anOperation! !

!AccessDescriptorMessage methodsFor: 'accessing' stamp: 'AK 2/6/2010 15:02'!
accessedKeyPath
	^accessedKeyPath! !

!AccessDescriptorMessage methodsFor: 'accessing' stamp: 'AK 2/6/2010 15:02'!
accessedKeyPath: keyPath
	accessedKeyPath := keyPath! !

!AccessDescriptorMessage methodsFor: 'accessing' stamp: 'AK 2/6/2010 15:02'!
accessedValue
	^accessedValue! !

!AccessDescriptorMessage methodsFor: 'accessing' stamp: 'AK 2/6/2010 15:03'!
accessedValue: aValue
	accessedValue := aValue! !

!AccessDescriptorMessage methodsFor: 'accessing' stamp: 'AK 2/6/2010 15:01'!
lastSender
	^lastSender! !

!AccessDescriptorMessage methodsFor: 'accessing' stamp: 'AK 2/6/2010 15:01'!
lastSender: sender
	lastSender := sender! !

!ManagedCollection methodsFor: 'private' stamp: 'AK 1/31/2010 14:59'!
actualCollection
"returns inner wrapped collection"

	^ actualCollection! !

!ManagedCollection methodsFor: 'private' stamp: 'AK 1/31/2010 14:59'!
actualCollection: aCollection
"sets inner wrapped collection"

	actualCollection :=  aCollection.! !

!ManagedCollection methodsFor: 'changing' stamp: 'AK 2/6/2010 19:24'!
add: anObject
"notifies bindees that anyone has changed collection
and forwards message to inner collection"

	| innerbindings ret changedescriptor |
	
	changedescriptor := ChangeDescriptorMessage new
			operation: #add;
			keyPathOfChange: #();
			lastSender: self;
			changedValue: anObject.
	
	innerbindings := Set new.
	self bindings allInnerBindings do: [ :innerbinding |
		innerbindings add: innerbinding localKeyPath
		].

	innerbindings do: [ :innerbinding |
		self bindings triggerEvent: #aboutToChange with: changedescriptor].
		ret := self actualCollection add: anObject.
	innerbindings do: [ :innerbinding |
		self bindings triggerEvent: #hasChanged with: changedescriptor].
	^ ret! !

!ManagedCollection methodsFor: 'accessing' stamp: 'AK 1/31/2010 15:02'!
arrangedObjects
"the arrangedobjects somebody can bind to (mapped to the actual collection)"

	<bindableAsCollection>
	self bindings triggerEvent: #accessed with: (self -> #arrangedObjects).
	^ self actualCollection! !

!ManagedCollection methodsFor: 'changing' stamp: 'AK 1/31/2010 15:01'!
at: aKey put: anObject
"notifies bindees that anyone has changed collection
and forwards message to inner collection"

	^ (self actualCollection respondsTo: #at:put:)
		ifTrue: [ | ret |
			self bindings triggerEvent: #aboutToChange with: (anObject).
			"unregister old object, if present"
			ret := self actualCollection at: aKey put: anObject.
			"register new object"
			self bindings triggerEvent: #hasChanged with: (anObject).
			ret]
		ifFalse: [self actualCollection at: aKey put: anObject]
! !

!ManagedCollection methodsFor: 'changing' stamp: 'AK 1/31/2010 15:00'!
do: aBlock
"notifies bindees that anyone has accessed collection
and forwards message to inner collection"

	self bindings triggerEvent: #accessed with: (self -> #arrangedObjects).
	^ self actualCollection do: aBlock.
! !

!ManagedCollection methodsFor: 'error handling' stamp: 'AK 1/31/2010 15:07'!
doesNotUnderstand: aMessage
"forwards the not understood message to the inner collection.
in the case that something is changed, this method calls an event hasChanged:"

	(self class knownMutators includes: aMessage selector)
		ifTrue: [
			| result |	
			self bindings triggerEvent: #aboutToChange with: (self actualCollection "????" -> aMessage selector).
			result := self actualCollection perform: aMessage selector withArguments: aMessage arguments.
			self bindings triggerEvent: #hasChanged with: (self actualCollection "????" -> aMessage selector).
			^ result	].
	^ self actualCollection perform: aMessage selector withArguments: aMessage arguments ! !

!ManagedCollection methodsFor: 'changing' stamp: 'AK 2/6/2010 19:26'!
remove: anObject ifAbsent: aBlock
"notifies bindees that anyone has changed collection
and forwards message to inner collection"

	| innerbindings ret changedescriptor |
	
	changedescriptor := ChangeDescriptorMessage new
			operation: #remove;
			keyPathOfChange: #();
			lastSender: self;
			changedValue: anObject.
	
	innerbindings := Set new.
	self bindings allInnerBindings do: [ :innerbinding |
		innerbindings add: innerbinding localKeyPath
		].
	
	innerbindings do: [ :innerbinding |
		self bindings triggerEvent: #aboutToChange with: changedescriptor].
	ret := self actualCollection remove: anObject ifAbsent: aBlock.
	innerbindings do: [ :innerbinding |
		self bindings triggerEvent: #hasChanged with: changedescriptor].
	^ ret! !

!BindingsManager methodsFor: 'reacting' stamp: 'AK 1/31/2010 12:23'!
aboutToChange: aBindingAssoc
"aboutToChange: is just an option to react
if s.b. wants to change, a.t.m. nobody reacts"! !

!BindingsManager methodsFor: 'reacting' stamp: 'AK 1/31/2010 12:23'!
accessed: aBindingAssoc
"accessed is just an option to react, if somebody
has accessed a variable and a.t.m. is not implemented"! !

!BindingsManager methodsFor: 'termination' stamp: 'AK 2/5/2010 23:09'!
alreadyContainsKey: localKeyPath

	| foundDescriptors |

	foundDescriptors := self observedBindings at: localKeyPath ifAbsent: [OrderedCollection new].
	
	^(foundDescriptors isEmpty not)! !

!BindingsManager methodsFor: 'accessing' stamp: 'AK 2/6/2010 15:36'!
bindingDescriptorForChangeDescriptor: aChangeDescriptor
"For a BindingsAssociation that arrives from the other side,
the corresponding (already set up) BindingsDescriptor is returned"

	|  target keyPath |
	target := aChangeDescriptor lastSender.
	keyPath := aChangeDescriptor keyPathOfChange.

	^ self allObservedBindings 
		detect: [:bd| 
			(bd target = target) and: [
			(bd keyPath = keyPath) and: [
			bd origin = self target]]]
		ifNone: [nil]! !

!BindingsManager methodsFor: 'accessing' stamp: 'AK 2/6/2010 15:44'!
bindingDescriptorsForInnerChangeDescriptor: aChangeDescriptor
"For a BindingsAssociation that arrives from the other side,
the corresponding (already set up) BindingsDescriptor is returned"

	|  target keyPath foundDescriptors |
	target := aChangeDescriptor lastSender.
	keyPath := aChangeDescriptor keyPathOfChange.
	foundDescriptors := OrderedCollection new.

	self allInnerBindings 
		do: [:bd| 
			((bd target = target) and: [
			(bd keyPath = keyPath) and: [
			bd origin = self target]])
				ifTrue: [
					foundDescriptors add: bd
				]].
	^foundDescriptors.! !

!BindingsManager methodsFor: 'accessing' stamp: 'AK 2/6/2010 17:59'!
hasChanged: aChangeDescriptorMessage
"if a value has changed on the other side, then this method
is called with association (changedObject->keypath).
The BindingsDescriptor is searched and the Morph setter called."

	| descriptor innerDescriptors |

	descriptor := self bindingDescriptorForChangeDescriptor: aChangeDescriptorMessage.
	innerDescriptors := self bindingDescriptorsForInnerChangeDescriptor: aChangeDescriptorMessage.

	"is incoming message from other side?"
	(descriptor isNil) ifFalse: [
			self otherSideHasChanged: descriptor].
		
	"If incoming message from inner bindings, then:
	Send ChangeDescriptorMessage to next receiver"
	(innerDescriptors)
		do: [ :bindingDescriptor |
				"Change ChangeDescriptorMessage's lastSender and keypath"
				aChangeDescriptorMessage lastSender: self target.
				aChangeDescriptorMessage keyPathOfChange: bindingDescriptor localKeyPath.
				self triggerEvent: #hasChanged
					with: aChangeDescriptorMessage
			].! !

!BindingsManager methodsFor: 'initialize-release' stamp: 'AK 2/6/2010 12:13'!
initialize
"On initialization intialize Dictionary for new BindingDescriptors"

	self observedBindings: Dictionary new.
	self innerBindings: Dictionary new.! !

!BindingsManager methodsFor: 'accessing' stamp: 'AK 2/6/2010 11:05'!
innerBindings
"returns alle observed bindings"

	^ innerBindings! !

!BindingsManager methodsFor: 'accessing' stamp: 'AK 2/6/2010 11:11'!
innerBindings: aDict
"set all inner bindings"

	innerBindings := aDict.! !

!BindingsManager methodsFor: 'accessing' stamp: 'AK 2/6/2010 11:07'!
innerKey: aKey
"Fetches one observed binding"

	^ self innerBindings at: aKey ifAbsentPut: [Set new]! !

!BindingsManager methodsFor: 'establishing' stamp: 'AK 1/31/2010 12:32'!
installEventHandlers: aBindingsDescriptor
"makes the BindingsManager on the other side react
on events with accessed:/aboutToChange:/hasChanged:"

	#( accessed aboutToChange hasChanged ) do: [:eventSymbol |
		aBindingsDescriptor target bindings 
			when: eventSymbol
			send: eventSymbol asMutator
			to: aBindingsDescriptor origin bindings].! !

!BindingsManager methodsFor: 'accessing' stamp: 'AK 2/6/2010 10:58'!
observedBindings
"returns alle observed bindings"

	^ observedBindings! !

!BindingsManager methodsFor: 'accessing' stamp: 'AK 2/6/2010 10:59'!
observedBindings: aColl
"set all observed bindings"

	observedBindings := aColl.! !

!BindingsManager methodsFor: 'accessing' stamp: 'AK 2/6/2010 11:12'!
observedKey: aKey
"Fetches a set of observed bindings for that key"

	^ self observedBindings at: aKey ifAbsentPut: [Set new]! !

!BindingsManager methodsFor: 'accessing' stamp: 'topa 2/8/2010 09:35'!
otherSideHasChanged: descriptor
"if a value has changed on the other side, then this method
is called with the Descriptor."

	| ownmessageName ownvalues othermessageName othervalues |

	(descriptor bindingType == #collection)
				ifTrue: [
					"fetch values from the other side"
					othervalues := descriptor target getValuesFromKeypath: descriptor keyPath.
															self halt.
					"get the collection from this side"
					ownvalues := self target getCollectionsFromKeypath: descriptor localKeyPath.
					
					"look if the target collection has any set up innerbinding.
					then it must have string values."
					
					"else it must have complex objects as values."

					"remove all values, iterate over collection and add values"
					ownvalues do: [ :coll |
						coll removeAll.
						othervalues do: [ :value |
							coll add: value
							]]].
				
	(descriptor bindingType == #value)
				ifTrue: [
					"fetch the last symbol"
					ownmessageName := descriptor localKeyPath last asMutator.
					"get the parent value object with the remaining symbols"
					ownvalues := descriptor origin getValuesFromKeypath: descriptor localKeyPath allButLast.
					"get the other side's message name"
					othermessageName := descriptor keyPath last.
					"get the other side's value object with the other side's descriptor"
					othervalues := descriptor target getValuesFromKeypath: descriptor keyPath allButLast.
					"set the first found value with first value from the other side"
					ownvalues first perform: ownmessageName with: (othervalues first perform: othermessageName) ].! !

!BindingsManager methodsFor: 'as yet unclassified' stamp: 'AK 1/31/2010 16:35'!
propertyName

	^propertyName.! !

!BindingsManager methodsFor: 'as yet unclassified' stamp: 'AK 1/31/2010 16:36'!
propertyName: name
"Name of this bindee in the contained object"

	propertyName := propertyName.! !

!BindingsManager methodsFor: 'establishing' stamp: 'AK 1/31/2010 12:35'!
recordBinding: aBindingsDescriptor
"Adds this BindingsDescriptor to the listened local keypathes"

	(self observedKey: aBindingsDescriptor localKeyPath) 
		add: aBindingsDescriptor.! !

!BindingsManager methodsFor: 'establishing' stamp: 'AK 2/6/2010 11:22'!
recordInnerBinding: aBindingsDescriptor
"Adds this BindingsDescriptor to the listened local keypathes"

	(self innerKey: aBindingsDescriptor localKeyPath) 
		add: aBindingsDescriptor.! !

!BindingsManager methodsFor: 'establishing' stamp: 'AK 2/6/2010 11:17'!
recordObservedBinding: aBindingsDescriptor
"Adds this BindingsDescriptor to the listened local keypathes"

	(self observedKey: aBindingsDescriptor localKeyPath) 
		add: aBindingsDescriptor.! !

!BindingsManager methodsFor: 'establishing' stamp: 'AK 2/6/2010 11:22'!
startObservingKey: localKeyPath as: type notifying: aMorph with: aKeyPath
"builds a Bindings Descriptor for new Binding, adds it and installs it"

	| descriptor |
	descriptor := (BindingsDescriptor as: type origin: (self target) localKeyPath: localKeyPath target: aMorph keyPath: aKeyPath).
	self
		recordObservedBinding: descriptor;
		installEventHandlers: descriptor.
! !

!BindingsManager methodsFor: 'termination' stamp: 'AK 2/6/2010 20:30'!
stopObservingKey: localKeyPath regarding: aMorph with: aKeyPath

	| foundDescriptors wantedDescriptor |
	
	wantedDescriptor := (BindingsDescriptor origin: (self target) localKeyPath: localKeyPath target: aMorph keyPath: aKeyPath).
	foundDescriptors := self observedBindings at: localKeyPath ifAbsent: [OrderedCollection new].
	
	foundDescriptors do: [ :foundDescriptor |
		(((foundDescriptor target) == (wantedDescriptor target)) and:
		[(foundDescriptor keyPath) literalEqual: (wantedDescriptor keyPath)])
			ifTrue: [
				self 
					forgetBinding: foundDescriptor;
					removeEventHandlers: foundDescriptor
				]].! !

!BindingsManager methodsFor: 'accessing' stamp: 'topa 12/29/2009 12:45'!
target: aMorph

	target := aMorph! !

!BindingsManager methodsFor: 'establishing' stamp: 'AK 2/6/2010 11:22'!
watchInnerKey: localKeyPath as: type notifying: aMorph with: aKeyPath
"builds a Bindings Descriptor for new Binding, adds it and installs it"

	| descriptor |
	descriptor := (BindingsDescriptor as: type origin: (self target) localKeyPath: localKeyPath target: aMorph keyPath: aKeyPath).
	self
		recordInnerBinding: descriptor;
		installEventHandlers: descriptor.
! !

!Object methodsFor: '*bindings-support' stamp: 'topa 1/26/2010 10:46'!
instVarNamedOrNil: name

	^ self instVarNamed: name ifAbsent: nil! !

!SelectableListMorph methodsFor: 'selection' stamp: 'topa 1/18/2010 19:09'!
selectionIndex: index
	"Called from outside to request setting a new selection."

	<bindable>
	| row |
	"bindings stub"
	(self listMorph selectedRow = index) ifTrue: [^self].
	self bindings triggerEvent: #aboutToChange with: (self -> #selection).
	self bindings triggerEvent: #aboutToChange with: (self -> #selectionIndex).

	"Called internally to select the index-th item."
	self unhighlightSelection.
	row := index ifNil: [ 0 ].
	row := row min: self getListSize.  "make sure we don't select past the end"
	self listMorph selectedRow: row.
	self highlightSelection.
	self scrollSelectionIntoView.
	
	self bindings triggerEvent: #hasChanged with: (self -> #selectionIndex).
	self bindings triggerEvent: #hasChanged with: (self -> #selection).
! !
